<template>
  <select
    :class="$style.select"
    v-model="selectedOption"
    :disabled="disabled"
    :name="name"
    @change="onChange"
  >
    <option v-if="showDefaultOption" :value="null"
      >Please Select One Item</option
    >
    <option
      v-for="(option, index) in options"
      :key="index"
      :value="option.value"
      :disabled="option.disabled"
      >{{ option.text }}</option
    >
  </select>
</template>

<script lang="ts">
import Vue from "vue";

export default Vue.extend({
  name: "Select",
  props: {
    disabled: {
      type: Boolean,
      required: false,
      default: false
    },
    name: {
      type: String,
      required: true,
      default: ""
    },
    hasIcon: {
      type: Boolean,
      required: false,
      default: true
    },
    options: {
      type: Array,
      required: true,
      default: function() {
        return [];
      }
    },
    showDefaultOption: {
      type: Object,
      required: false,
      default: function() {
        return {};
      }
    }
  },
  data: function() {
    return {
      selectedOption: null
    };
  },
  methods: {
    onChange: function() {
      this.$emit("onSelect", this.selectedOption);
    }
  }
});
</script>

<style module lang="scss">
.select {
  width: 220px;
  height: 45px;
  padding-left: $padding-left--default;
  background: white;
  border-radius: 2px;
  border: 1px solid #eaeaea;
  box-shadow: $shadow--default;
}

@media screen and (max-width: $device-size--mobile-large) {
  .select {
    width: 100%;
  }
}
</style>
